#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <climits>

using namespace std;

#define MAX 3
#define V 10

int moedas[MAX] = {1,3,4};
//int V = 6;

int MEMO[V+1];
//int MEMO1[MAX+1];


void printMEMO(int vet[]){
	for (int i = 0; i <= V; ++i) {
		printf("%d ", vet[i]);
	}
	printf("\n");
}

int moedaREC(int v){
	if (v == 0)
		return 0;
	if (v < 0)
		return INT_MAX-1;

	int menor = INT_MAX;
	for (int i = 0; i < MAX; ++i) { // para todas as moedas
		//if (v >= moedas[i])
			menor = min(1+moedaREC(v-moedas[i]), menor);
	}

	return menor;
}


int moedaRECPD(int v){
	if (v == 0)
		return 0;
	if (v < 0)
		return INT_MAX-1;

	if (MEMO[v] != -1) // ja foi calculado...
		return MEMO[v];

	MEMO[v] = INT_MAX;
	for (int i = 0; i < MAX; ++i) { // para todas as moedas
		//if (v >= moedas[i])
			MEMO[v] = min(1+moedaRECPD(v-moedas[i]), MEMO[v]);
	}
	
	return MEMO[v];
}


int moedaPD(){
	// PARA TODOS OS POSSIVEIS VALORES j de V  !!!!
	for (int j = 1; j <= V; ++j) {
		MEMO[j] = INT_MAX;
			for (int i = 0; i < MAX; ++i) { // para todas as moedas
				printf("%d\n", j-moedas[i]);
				if (j >= moedas[i])
					MEMO[j] = min(1+MEMO[j-moedas[i]], MEMO[j]);
			}
	
	}
	return MEMO[V];
}



int main(int argc, char const *argv[])
{
	printf("O nro minimo de moedas eh  %d\n", moedaREC(V));

	memset(MEMO, -1, sizeof MEMO);
	printf("O nro minimo de moedas REC PD eh  %d\n", moedaRECPD(V));
	printMEMO(MEMO);


	MEMO[0] = 0; // fundamental.... 
	printf("O nro minimo de moedas  PD eh  %d\n", moedaPD());
	printMEMO(MEMO);
	
	return 0;
}