#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>

using namespace std;

#define MAX 6

int peso[MAX+1] = {0,2,4,4,7,2,1};
int p[MAX+1] = {0,0,0,1,0,3,3};

int MEMO[MAX+1];
int MEMO1[MAX+1];


void printMEMO(int vet[]){
	for (int i = 0; i <= MAX; ++i) {
		printf("%d ", vet[i]);
	}
	printf("\n");
}

int wispREC(int j){
	if (j == 0)
		return 0;
	return max(peso[j]+wispREC(p[j]), wispREC(j-1));

}


int wispRECPD(int j){
	if (j == 0)
		return 0;

	// se ja calculei, retorna o valor
	if (MEMO[j] != -1)
		return MEMO[j];

	MEMO[j] = max(peso[j]+wispRECPD(p[j]), wispRECPD(j-1));
	return MEMO[j];

}


int wispPD(){
	
	for (int j = 1; j <= MAX; ++j)   // para todos os intervalo
	{
		MEMO1[j] = max(peso[j]+MEMO1[p[j]], MEMO1[j-1]);
	}

	return MEMO1[MAX];
}




int main(int argc, char const *argv[])
{
	printf("O maior valor do WISP eh %d\n", wispREC(MAX));
	memset(MEMO, -1, sizeof MEMO);

	printf("O maior valor do WISP REC PD ... eh %d\n", wispRECPD(MAX));
	printMEMO(MEMO);

	MEMO1[0] = 0;
	printf("O maior valor do WISP ITER PD ... eh %d\n", wispPD());
	printMEMO(MEMO1);
	return 0;
}