  
 /*
  itens[MAX] = {15, 20, 5, 7, 40, 23}

  W = 4;

	se consumi todos os itens, então nao tem peso.... 0
  Caso base: wssp(-1) = 0
*/


#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;

//#define W 39
#define W 6
//#define ITENS 6
#define ITENS 3

//int peso[ITENS] = {15, 20, 5, 7, 40, 23};
int peso[ITENS] = {2, 2, 3};


int wsspRec(int item, int Pres){
	// percorreu todos os item.. nao achou nada...
	if (item == -1)
		return 0;

	// o item nao cabe na mochila.. despreza.....
	if (peso[item] > Pres)
		return wsspRec(item-1, Pres);

	return max(wsspRec(item-1,Pres), peso[item]+wsspRec(item-1, Pres-peso[item]));

}

int M1[ITENS][W+1];      // para a versao recursiva, nao usamos a posicao 0...
int M2[ITENS+1][W+1];

void printM(int m[][W+1], int t){
	int linhas;
	t == 1 ? linhas = ITENS-1 : linhas = ITENS;
	for (int i = linhas; i >= 0 ; i--){
		for (int j = 0; j <= W; j++)
			printf("%d ", m[i][j]);
		printf("\n");
	}
	printf("\n");
}




int wsspRecPD(int item, int Pres){
	// percorreu todos os item.. nao achou nada...
	if (item == -1)
		return 0;
	// ja calculei isso..... então retorna o que está na tabela...
	if (M1[item][Pres] != -1)
		return M1[item][Pres];

	// o item nao cabe na mochila.. despreza.....
	if (peso[item] > Pres)
		return M1[item][Pres] = wsspRecPD(item-1, Pres);

	M1[item][Pres] = max(wsspRecPD(item-1,Pres), peso[item]+wsspRecPD(item-1, Pres-peso[item]));

	return M1[item][Pres];
}


int wsspPD(){

	for (int i = 1; i <= ITENS; i++){ // para todos os itens
		for (int j = 0; j <=W; j++)    // para todos os pesos...
			if (peso[i-1] > j)
				M2[i][j] = M2[i-1][j];
			else M2[i][j] = max(M2[i-1][j], peso[i-1]+M2[i-1][j-peso[i-1]]);

	}
	return M2[ITENS][W];
}


int main(int argc, char const *argv[])
{

	printf("O peso maximo na mochila eh %d\n", wsspRec(ITENS-1, W));

	memset(M1, -1, sizeof M1);
	printf("O peso maximo na mochila eh %d\n", wsspRecPD(ITENS-1, W));
	printM(M1,1);
	printf("\n");

	for (int i = 0; i <= W; ++i)
		M2[0][i] = 0;
	printf("O peso maximo na mochila eh %d\n", wsspPD());
	printM(M2,2);

	return 0;
}